PGSQL_CONTROL
-- $Id: cmp_array.m4,v 1.3 2004/10/16 21:56:50 babolo Exp $
CREATE OR REPLACE FUNCTION cmpstrarrlt(text[], text[]) RETURNS bool
 AS 'DECLARE loopn integer := 1;
             result bool := FALSE;
     BEGIN
         LOOP
             IF $1[loopn] IS NULL AND $2[loopn] IS NULL THEN EXIT; END IF;
             IF $1[loopn] <> $2[loopn]
             THEN result := ($1[loopn] < $2[loopn]); EXIT;
             END IF;
             loopn := loopn + 1;
         END LOOP;
         RETURN result;
     END;
    '
 LANGUAGE PLPGSQL IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION cmpstrarrgt(text[], text[]) RETURNS bool
 AS 'DECLARE loopn integer := 1;
             result bool := FALSE;
     BEGIN
         LOOP
             IF $1[loopn] IS NULL AND $2[loopn] IS NULL THEN EXIT; END IF;
             IF $1[loopn] <> $2[loopn]
             THEN result := ($1[loopn] > $2[loopn]); EXIT;
             END IF;
             loopn := loopn + 1;
         END LOOP;
         RETURN result;
     END;
    '
 LANGUAGE PLPGSQL IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION compare(integer,text[],text[]) RETURNS bool
 AS 'DECLARE loopn integer := 1;
             result bool := TRUE;
     BEGIN
         IF $1 IS NULL THEN RETURN FALSE; END IF;
         LOOP
             IF loopn > $1 THEN EXIT; END IF;
             IF $2[loopn] <> $3[loopn]
             THEN result := FALSE; EXIT;
             END IF;
             loopn := loopn + 1;
         END LOOP;
         RETURN result;
     END;
    '
 LANGUAGE PLPGSQL IMMUTABLE
;
CREATE OR REPLACE FUNCTION cmpstrarrge(text[], text[]) RETURNS bool
 AS 'SELECT cmpstrarrlt($1, $1)
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION cmpstrarrle(text[], text[]) RETURNS bool
 AS 'SELECT cmpstrarrgt($1, $1)
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
CREATE OPERATOR <
     ( LEFTARG = text[]
     , RIGHTARG = text[]
     , PROCEDURE = cmpstrarrlt
     , COMMUTATOR = >
     , NEGATOR = >=
     )
;
CREATE OPERATOR >
     ( LEFTARG = text[]
     , RIGHTARG = text[]
     , PROCEDURE = cmpstrarrgt
     , COMMUTATOR = <
     , NEGATOR = <=
     )
;
CREATE OPERATOR >=
     ( LEFTARG = text[]
     , RIGHTARG = text[]
     , PROCEDURE = cmpstrarrge
     , COMMUTATOR = <=
     , NEGATOR = <
     )
;
CREATE OPERATOR <=
     ( LEFTARG = text[]
     , RIGHTARG = text[]
     , PROCEDURE = cmpstrarrle
     , COMMUTATOR = >=
     , NEGATOR = >
     )
;
COMMENT ON FUNCTION cmpstrarrge(text[],text[])     IS '  >=   ';
COMMENT ON FUNCTION cmpstrarrgt(text[],text[])     IS '  >   ';
COMMENT ON FUNCTION cmpstrarrle(text[],text[])     IS '  <=   ';
COMMENT ON FUNCTION cmpstrarrlt(text[],text[])     IS '  <   ';
COMMENT ON FUNCTION compare(integer,text[],text[]) IS '  $1   $2  $3';
